'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _cssShorthandExpand = require('css-shorthand-expand');

var _cssShorthandExpand2 = _interopRequireDefault(_cssShorthandExpand);

var _colorShorthandHexToSixDigit = require('color-shorthand-hex-to-six-digit');

var _colorShorthandHexToSixDigit2 = _interopRequireDefault(_colorShorthandHexToSixDigit);

var _camelizeStyleName = require('fbjs/lib/camelizeStyleName');

var _camelizeStyleName2 = _interopRequireDefault(_camelizeStyleName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function canExpandRule(name) {
  return ['background', 'font', 'padding', 'margin', 'border', 'border-width', 'border-style', 'border-color', 'border-top', 'border-right', 'border-bottom', 'border-left', 'border-radius', 'outline'].includes(name);
}

function convertCssPairsToStyle(rules) {
  return rules
  // Expand shorthand rules
  .reduce(function (out, _ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        name = _ref2[0],
        value = _ref2[1];

    if (canExpandRule(name)) {
      var expanded = (0, _cssShorthandExpand2.default)(name, value);
      var next = Object.keys(expanded).map(function (rule) {
        return [rule, expanded[rule]];
      });
      return [].concat(_toConsumableArray(out), _toConsumableArray(next));
    }
    return [].concat(_toConsumableArray(out), [[name, value]]);
  }, [])
  // Expand colors to 6 digits and build result
  .reduce(function (out, _ref3) {
    var _ref4 = _slicedToArray(_ref3, 2),
        name = _ref4[0],
        value = _ref4[1];

    return _extends({}, out, _defineProperty({}, (0, _camelizeStyleName2.default)(name), /color/i.test(name) ? (0, _colorShorthandHexToSixDigit2.default)(value) : value));
  }, {});
}

exports.default = convertCssPairsToStyle;