'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.resetStyleCache = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _hash = require('styled-components/lib/vendor/glamor/hash');

var _hash2 = _interopRequireDefault(_hash);

var _flatten = require('styled-components/lib/utils/flatten');

var _flatten2 = _interopRequireDefault(_flatten);

var _postcssSafeParser = require('postcss-safe-parser');

var _postcssSafeParser2 = _interopRequireDefault(_postcssSafeParser);

var _cssToStyle = require('./css-to-style');

var _cssToStyle2 = _interopRequireDefault(_cssToStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var generated = {};

var resetStyleCache = exports.resetStyleCache = function resetStyleCache() {
  generated = {};
};

exports.default = function (stylesheet) {
  return function () {
    function InlineMailStyle(rules) {
      _classCallCheck(this, InlineMailStyle);

      this.rules = rules;
    }

    _createClass(InlineMailStyle, [{
      key: 'generateStyleObject',
      value: function generateStyleObject(executionContext) {
        var flatStyles = (0, _flatten2.default)(this.rules, executionContext).join('');
        var hash = (0, _hash2.default)(flatStyles);
        if (!generated[hash]) {
          var rules = [];
          (0, _postcssSafeParser2.default)(flatStyles).each(function (node) {
            switch (node.type) {
              case 'decl':
                rules.push([node.prop, node.value]);
                return;
              case 'comment':
                return;
              default:
                if (process.env.NODE_ENV !== 'production') {
                  console.warn('Node of type ' + node.type + ' not supported as an inline style');
                }
            }
          });
          var styles = (0, _cssToStyle2.default)(rules);
          var instance = stylesheet.create({ generated: styles });
          generated[hash] = instance.generated;
        }
        return generated[hash];
      }
    }]);

    return InlineMailStyle;
  }();
};